%%
%%  main.pl:  Top-level prolog file for MIndiGolog
%%

:- use_module('clpqr/clpq').


:- discontiguous(trans/4, final/2, prim_action/1, natural/1, poss/3,
                 conflicts/3, start/2,proc/2).

%%
%%  Provide Syntactic operators for MIndiGolog programs
%%
%%  These operators form the "syntactic sugar" for MIndiGolog programs
%%
:- op(660,xfy,/).  % Nondeterministic choice
:- op(650,xfy,:).  % Sequence
:- op(640,xfy,//). % Concurrent execution
:- op(640,xfy,>>). % Prioritised concurrency
:- op(620,fx,?).   % Test

%%
%%  Include the relevant definitions
%%
:- include(mindigolog).
:- include(sitcalc).
:- include(domain).
:- include(program_proposed).


%%
%%  main(Args):  main entry-point for program execution
%%
%%  This predicate is designed as the entry-point for the program,
%%  it calls the MIndiGolog procedure "control" in an off-line manner.
%%
main(Args) :-
    ( length(Args,0) ->
        nl, ol_do(control,s0), nl
    ;
        nl, display('ERROR: No arguments can be given'), nl
    ).

