%%
%%  MIndiGolog procedures
%%  Kithcen Domain
%%
%%  Three Dishes, Salad, Beefsteak and Grilled Bacon
%%  Two Agents, Kithcen hand and Chef
%%  5*5 universe	
%%  is_nearest algorithm is implemented


%%  Ensure that the kitchenhand has control of an object, if it's dirty, clean it.
proc(ensureKhHas(Kh,Obj),
     if(has_object(Kh,Obj,now),
		acquire_object(Kh,Obj),
		  acquire_object(Kh,Obj)     
		: doGotoObj(Kh,Obj)
		: if(is_clean(Obj,now),nil,doClean(Kh,Obj))
	)
    ).

%%  Ensure that the kitchenhand has table or sink
proc(ensureKhHasTable(Kh,Tb),
     if(has_object(Kh,Tb,now),
		acquire_object(Kh,Tb),
		  acquire_object(Kh,Tb)     
		: doGotoObj(Kh,Tb)
	)
    ).

%%  Ensure that the chef has an object, if object is not clean, ask a kitchen hand to clean it.
proc(ensureChHas(Ch,Obj),
     if(has_object(Ch,Obj,now),
		nil,
			if(is_clean(Obj,now),
					acquire_object(Ch,Obj)
					:doGotoObj(Ch,Obj)
					,
					pi(kh,?and(kitchenhand(kh),is_nearest_obj(Obj,kh,now))
					:ensureKhHas(kh,Obj) %% when ensureKhHas, KH will clean it 
					:release_object(kh,Obj)
				        )
					:acquire_object(Ch,Obj)
					:doGotoObj(Ch,Obj)
			   )
			     
	)
    ).

%% Kitchen hands go from where they sit to block B
proc(doGoto(Kh,B),
	 if(and(staff_is_in_block(Kh,block00,now),B\=block00),begin_task(Kh,goto(block00,B)):end_task(Kh,goto(block00,B)),
	 if(and(staff_is_in_block(Kh,block01,now),B\=block01),begin_task(Kh,goto(block01,B)):end_task(Kh,goto(block01,B)),
	 if(and(staff_is_in_block(Kh,block02,now),B\=block02),begin_task(Kh,goto(block02,B)):end_task(Kh,goto(block02,B)),
	 if(and(staff_is_in_block(Kh,block03,now),B\=block03),begin_task(Kh,goto(block03,B)):end_task(Kh,goto(block03,B)),
	 if(and(staff_is_in_block(Kh,block04,now),B\=block04),begin_task(Kh,goto(block04,B)):end_task(Kh,goto(block04,B)),
	 if(and(staff_is_in_block(Kh,block10,now),B\=block10),begin_task(Kh,goto(block10,B)):end_task(Kh,goto(block10,B)),
	 if(and(staff_is_in_block(Kh,block11,now),B\=block11),begin_task(Kh,goto(block11,B)):end_task(Kh,goto(block11,B)),
	 if(and(staff_is_in_block(Kh,block12,now),B\=block12),begin_task(Kh,goto(block12,B)):end_task(Kh,goto(block12,B)),
	 if(and(staff_is_in_block(Kh,block13,now),B\=block13),begin_task(Kh,goto(block13,B)):end_task(Kh,goto(block13,B)),
	 if(and(staff_is_in_block(Kh,block14,now),B\=block14),begin_task(Kh,goto(block14,B)):end_task(Kh,goto(block14,B)),
	 if(and(staff_is_in_block(Kh,block20,now),B\=block20),begin_task(Kh,goto(block20,B)):end_task(Kh,goto(block20,B)),
	 if(and(staff_is_in_block(Kh,block21,now),B\=block21),begin_task(Kh,goto(block21,B)):end_task(Kh,goto(block21,B)),
	 if(and(staff_is_in_block(Kh,block22,now),B\=block22),begin_task(Kh,goto(block22,B)):end_task(Kh,goto(block22,B)),
	 if(and(staff_is_in_block(Kh,block23,now),B\=block23),begin_task(Kh,goto(block23,B)):end_task(Kh,goto(block23,B)),
	 if(and(staff_is_in_block(Kh,block24,now),B\=block24),begin_task(Kh,goto(block24,B)):end_task(Kh,goto(block24,B)),
	 if(and(staff_is_in_block(Kh,block30,now),B\=block30),begin_task(Kh,goto(block30,B)):end_task(Kh,goto(block30,B)),
	 if(and(staff_is_in_block(Kh,block31,now),B\=block31),begin_task(Kh,goto(block31,B)):end_task(Kh,goto(block31,B)),
	 if(and(staff_is_in_block(Kh,block32,now),B\=block32),begin_task(Kh,goto(block32,B)):end_task(Kh,goto(block32,B)),
	 if(and(staff_is_in_block(Kh,block33,now),B\=block33),begin_task(Kh,goto(block33,B)):end_task(Kh,goto(block33,B)),
	 if(and(staff_is_in_block(Kh,block34,now),B\=block34),begin_task(Kh,goto(block34,B)):end_task(Kh,goto(block34,B)),
	 if(and(staff_is_in_block(Kh,block40,now),B\=block40),begin_task(Kh,goto(block40,B)):end_task(Kh,goto(block40,B)),
	 if(and(staff_is_in_block(Kh,block41,now),B\=block41),begin_task(Kh,goto(block41,B)):end_task(Kh,goto(block41,B)),
	 if(and(staff_is_in_block(Kh,block42,now),B\=block42),begin_task(Kh,goto(block42,B)):end_task(Kh,goto(block42,B)),
	 if(and(staff_is_in_block(Kh,block43,now),B\=block43),begin_task(Kh,goto(block43,B)):end_task(Kh,goto(block43,B)),
	 if(and(staff_is_in_block(Kh,block44,now),B\=block44),begin_task(Kh,goto(block44,B)):end_task(Kh,goto(block44,B)),nil
	)))))))))))))))))))))))))
	
    ).

%% Kitchen hands go from where they sit to where the Obj sit
proc(doGotoObj(Kh,Obj),
		if(obj_is_in_block(Obj,block00,now),doGoto(Kh,block00),
		if(obj_is_in_block(Obj,block01,now),doGoto(Kh,block01),
		if(obj_is_in_block(Obj,block02,now),doGoto(Kh,block02),
		if(obj_is_in_block(Obj,block03,now),doGoto(Kh,block03),
		if(obj_is_in_block(Obj,block04,now),doGoto(Kh,block04),
		if(obj_is_in_block(Obj,block10,now),doGoto(Kh,block10),
		if(obj_is_in_block(Obj,block11,now),doGoto(Kh,block11),
		if(obj_is_in_block(Obj,block12,now),doGoto(Kh,block12),
		if(obj_is_in_block(Obj,block13,now),doGoto(Kh,block13),
		if(obj_is_in_block(Obj,block14,now),doGoto(Kh,block14),
		if(obj_is_in_block(Obj,block20,now),doGoto(Kh,block20),
		if(obj_is_in_block(Obj,block21,now),doGoto(Kh,block21),
		if(obj_is_in_block(Obj,block22,now),doGoto(Kh,block22),
		if(obj_is_in_block(Obj,block23,now),doGoto(Kh,block23),
		if(obj_is_in_block(Obj,block24,now),doGoto(Kh,block24),
		if(obj_is_in_block(Obj,block30,now),doGoto(Kh,block30),
		if(obj_is_in_block(Obj,block31,now),doGoto(Kh,block31),
		if(obj_is_in_block(Obj,block32,now),doGoto(Kh,block32),
		if(obj_is_in_block(Obj,block33,now),doGoto(Kh,block33),
		if(obj_is_in_block(Obj,block34,now),doGoto(Kh,block34),
		if(obj_is_in_block(Obj,block40,now),doGoto(Kh,block40),
		if(obj_is_in_block(Obj,block41,now),doGoto(Kh,block41),
		if(obj_is_in_block(Obj,block42,now),doGoto(Kh,block42),
		if(obj_is_in_block(Obj,block43,now),doGoto(Kh,block43),
		if(obj_is_in_block(Obj,block44,now),doGoto(Kh,block44),nil
	)))))))))))))))))))))))))
	
    ).

%% Kitchen hand clean Obj, Obj is raw material or utensil
%% A sink is selected by the is_nearest algorithm
proc(doClean(Kh,Obj),
	pi(mySink, ?and(obj_is_type(mySink,sink),is_nearest_kh(Kh,mySink,now))
		   : ensureKhHasTable(Kh,mySink)
		   : doGotoObj(Kh,mySink)	
		   : begin_task(Kh,clean(Obj,mySink))
		   : end_task(Kh,clean(Obj,mySink))
		   : release_object(Kh,mySink)
	  )	
	
    ).

%% Initial the first location of each objects and agents
proc(doInitial,
	initial_staff_location(kh01,block10)//
	initial_staff_location(kh02,block10)//
	initial_staff_location(kh03,block10)//
	initial_staff_location(kh04,block10)//
	initial_staff_location(kh05,block10)//
	initial_staff_location(chef01,block10)//
	initial_obj_location(bowl1,block20)//
	initial_obj_location(bowl2,block20)//
	initial_obj_location(bowl3,block20)//
	initial_obj_location(pan1,block20)//
	initial_obj_location(board1,block20)//
	initial_obj_location(board2,block20)//
	initial_obj_location(beefstake1,block30)//
	initial_obj_location(bacon1,block30)//
	initial_obj_location(tomato1,block30)//
	initial_obj_location(lettuce1,block30)//
	initial_obj_location(carrot1,block30)//
	initial_obj_location(oven1,block23)//
	initial_obj_location(grill1,block24)//
	initial_obj_location(table1,block01)//
	initial_obj_location(table2,block43)//
	initial_obj_location(sink1,block44)//
	initial_obj_location(sink2,block04)//
	initial_obj_location(sink3,block40)//
	initial_obj_location(sink4,block00)
    ).


%%  Nondeterministically select an object of a given type, gain control
%%  of it, and place it inside a utensil.
proc(doPlaceTypeIn(Kh,Type,Dest),
     pi(obj,?obj_is_type(obj,Type)
		: ensureKhHas(Kh,obj)
		: place_in(Kh,obj,Dest)
       )
    ).


%%  Make grilled bacon into the specified utensil.  This involves
%%  cut bacon into a pan, then grill it in a grill.
proc(makeBacon(Dest),
	pi(myPan,?obj_is_type(myPan,pan)
 	        :pi(kh,?and(kitchenhand(kh),is_nearest_obj(myPan,kh,now))
				: pi(obj, ?obj_is_type(obj,bacon)
				: doCutInto(kh,obj,myPan)
				)
	                )
     		: pi(myGrill, ?obj_is_type(myGrill,grill)
                  : pi(ch,  ?chef(ch)
			    : ensureChHas(ch,myPan)
			    : ensureChHas(ch,myGrill)	
                            : transfer(ch,myPan,myGrill)
			    : release_dirty_object(ch,myPan)//release_object(ch,myGrill)	
                            : set_timer(ch,grillTimer,15)
                      )
                  : ring_timer(grillTimer)
                  : pi(ch,?chef(ch)
				: ensureChHas(ch,Dest)
				: ensureChHas(ch,myGrill)
				: transfer(ch,myGrill,Dest)
			        : release_dirty_object(ch,myGrill)//release_object(ch,Dest)	
                      )
		)
         )
    ).


%%  Marinate the steak in a utensil.
proc(makeSteakMarinate(Dest),
     pi(kh,?and(kitchenhand(kh),is_nearest_obj(Dest,kh,now)) 
	: ensureKhHas(kh,Dest)
	: doPlaceTypeIn(kh,beefstake,Dest)
	: begin_task(kh,marinate(Dest,5))
	: end_task(kh,marinate(Dest,5))
	: release_object(kh,Dest)
       )
    ).

%%  Make steak into the specified utensil.  This involves
%%  marinate steak and bake it in an oven.
proc(makeSteak(Dest),
     makeSteakMarinate(Dest)
     : pi(myOven, ?obj_is_type(myOven,oven)
                  : pi(ch, ?chef(ch)
			    : ensureChHas(ch,Dest)
			    : ensureChHas(ch,myOven)	
                            : transfer(ch,Dest,myOven)
			    : release_dirty_object(ch,Dest)//release_object(ch,myOven)
                            : set_timer(ch,bakeSteakTimer,10)
                      )
                  : ring_timer(bakeSteakTimer)
                  : pi(ch, ?chef(ch)
			    : ensureChHas(ch,Dest)
			    : ensureChHas(ch,myOven)	
			    : transfer(ch,myOven,Dest)
			    : release_dirty_object(ch,myOven)//release_object(ch,Dest)	
		      )
         )
    ).

%%  Cut the given item then place it in the given utensil.
%%  Releases control of the utensil when done.  An cutting
%%  board is selected by the is_nearest algorithm.
proc(doCutInto(Kh,Obj,Dest),
        ensureKhHas(Kh,Obj)
        : pi(myBoard, ?and(obj_is_type(myBoard,board),is_nearest_kh(Kh,myBoard,now))
	   : ensureKhHas(Kh,myBoard)
	   : pi(myTable, ?and(obj_is_type(myTable,table),is_nearest_kh(Kh,myTable,now))
		   : ensureKhHasTable(Kh,myTable)
		   : doGotoObj(Kh,myTable)	
                   : place_in(Kh,Obj,myBoard)
                   : begin_task(Kh,cut(myBoard,myTable))
                   : end_task(Kh,cut(myBoard,myTable))
                   : ensureKhHas(Kh,Dest)
                   : transfer(Kh,myBoard,Dest)
		   : release_object(Kh,myTable)//release_dirty_object(Kh,myBoard)//release_object(Kh,Dest)
	  )	
        )
    ).



%%  Make a salad in the specified utensil.  This involves selecting
%%  appropriate vegetables, wash them, cutting them, placing them in the utensil,
%%  and chef will mix them briefly.
proc(makeSalad(Dest),
       pi(kh,?and(kitchenhand(kh),is_nearest_obj(Dest,kh,now))
			: pi(obj, ?obj_is_type(obj,lettuce)
			: doCutInto(kh,obj,Dest)
                )
         )
       //
       pi(kh,?and(kitchenhand(kh),is_nearest_obj(Dest,kh,now))
			: pi(obj, ?obj_is_type(obj,tomato)
                        : doCutInto(kh,obj,Dest)
                )
         )
      //
      pi(kh,?and(kitchenhand(kh),is_nearest_obj(Dest,kh,now))
			: pi(obj, ?obj_is_type(obj,carrot)
                        : doCutInto(kh,obj,Dest)
                )
        )
    : pi(ch, ?chef(ch)
		:ensureChHas(ch,Dest)
                : begin_task(ch,mix(Dest,5))
                : end_task(ch,mix(Dest,5))
                : release_object(ch,Dest)
        )
    ).


%%  Main control program - prepare a nice meal
proc(control,
	doInitial
%%	:makeSalad(bowl2)
%%	:	makeSteak(bowl1)  
	:	makeBacon(bowl3)
    ).

